#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/mpu/rtc.h>
#include <gint/rtc.h>
#include <gint/clock.h>
/******************************************************************************/
unsigned int seed=0;
int partrand(){
  rtc_time_t time;
  rtc_get_time (& time);
  return time.seconds+time.seconds;
}
int rand(){
  seed+=partrand();
  return(seed);
}
void printcase (int x, int y, color_t color){
	x+=1;
	y+=1;
	drect (x*10, y*10, (x*10)+10, (y*10)+10, color);
}
void printMatrice(int x, int y,int matrice[x][y], int taille){
  dclear(C_WHITE);
  for (int i=0;i<x;i++){
    for (int j=0;j<y;j++){
      if (i==0){printcase(i-1,j, C_RED);}
      if (i==x-1){printcase(i+1, j , C_RED);}
      if (j==0){printcase(i,j-1, C_RED);}
      if (j==y-1){printcase(i,j+1,C_RED);}
    	if (matrice[i][j]>0){
    		printcase(i, j, C_BLACK);}
    		else{
    			if(matrice[i][j]<0){
    				printcase(i,j, C_BLUE);}
    	}
    }
  }
}
int loop(int lignes, int colonnes){
  
  int ecran[colonnes][lignes];
  for (int i=0;i<colonnes;i++){
    for (int j=0;j<lignes;j++){
      ecran[i][j]=0;}}
  int taille=5;
  int X=1;
  int Y=1;
  char dirX=1;
  char dirY=0;
  int objX=rand()%colonnes;
  int objY=rand()%lignes;
  int objval=-(rand()%3)-1;
  int speed=500;
  while(1){
  	dupdate();
    sleep_ms(1,speed);
    ecran[objX][objY]=objval;
    if (keydown(KEY_DOWN)==1){dirY=1;dirX=0;}
    if (keydown(KEY_UP)==1){dirY=-1;dirX=0;}
    if (keydown(KEY_RIGHT)==1){dirX=1;dirY=0;}
    if (keydown(KEY_LEFT)==1){dirX=-1;dirY=0;}
    if (keydown(KEY_F1)==1){speed/=1.25;}
    if (keydown(KEY_F2)==1){speed*=1.25;}
    if(keydown(KEY_EXIT)==1){return (-1);}
    clearevents();
    X+=dirX;
    Y+=dirY;
    if (X>colonnes-1){X=colonnes-1;}if (X<0){X=0;}if (Y<0){Y=0;}if (Y>lignes-1){Y=lignes-1;}
    if (ecran[X][Y]<0){
    	taille-=objval;
    	objX=rand()%colonnes;
    	objY=rand()%lignes;
    	objval=-(rand()%3)-1;}
    if (ecran[X][Y]>0){return 1;}
    ecran[X][Y]=taille;
    printMatrice(colonnes,lignes,ecran,taille);
    for (int i=0;i<colonnes;i++){
      for (int j=0;j<lignes;j++){
			if (ecran[i][j]>0){ecran[i][j]--;}
		}
	}
}
return 0;
}
int main(){
  int lignes=20;
  int colonnes=36;
  while (1){
	  if(loop(lignes, colonnes)==-1){
	  	break;
}
  return (0);
}

}
